Debian Bug report logs - #514249
Does dpkg-cross still need to support the -dcv1 compatibility packages?

version graph

Package: dpkg-cross; Maintainer for dpkg-cross is Debian Embedded Group <debian-embedded@lists.debian.org>; Source for dpkg-cross is src:dpkg-cross.

Reported by: Wookey <wookey@debian.org>

Date: Thu, 5 Feb 2009 16:54:04 UTC

Severity: wishlist

Tags: patch

Found in version dpkg-cross/2.3.0.1

Fixed in version dpkg-cross/2.4.0

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#514249; Package dpkg-cross. (Thu, 05 Feb 2009 16:54:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Thu, 05 Feb 2009 16:54:07 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Wookey <wookey@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Does dpkg-cross still need to support the -dcv1 compatibility packages?
Date: Thu, 05 Feb 2009 16:51:33 +0000
Package: dpkg-cross
Version: 2.3.0.1
Severity: wishlist


dpkg-cross introduced -dcv1 packages for compatibility with older
installations, ooh, quite a some time ago now. Something to do with
changing formats. Is this code still actually useful (i.e is anyone
still using a system with bits on so old that this stuff helps), or
should we just drop it now?

Needs a bit of research to remind ourselves of the issue.

-- System Information:
Debian Release: 5.0
  APT prefers testing
  APT policy: (990, 'testing'), (600, 'unstable'), (300, 'stable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-1-amd64 (SMP w/1 CPU core)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages dpkg-cross depends on:
ii  binutils-multiarch  2.18.1~cvs20080103-7 Binary utilities that support mult
ii  debconf [debconf-2. 1.5.24               Debian configuration management sy
ii  dpkg-dev            1.14.24              Debian package development tools
ii  libdebian-dpkgcross 2.3.0.1              functions to aid cross-compiling D
ii  perl                5.10.0-19            Larry Wall's Practical Extraction 

Versions of packages dpkg-cross recommends:
ii  fakeroot                      1.11       Gives a fake root environment

dpkg-cross suggests no packages.

-- debconf information excluded

______________________________________________________________________
This email has been scanned by the MessageLabs Email Security System.
For more information please visit http://www.messagelabs.com/email 
______________________________________________________________________




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#514249; Package dpkg-cross. (Tue, 10 Feb 2009 15:00:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Tue, 10 Feb 2009 15:00:06 GMT) Full text and rfc822 format available.

Message #10 received at 514249@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 514249@bugs.debian.org
Cc: 514249-submitter@bugs.debian.org, Nikita Youshchenko <yoush@debian.org>, control@bugs.debian.org
Subject: History of the change
Date: Tue, 10 Feb 2009 14:47:29 +0000
[Message part 1 (text/plain, inline)]
Package: dpkg-cross
tag 514249 + patch
thanks

This was introduced in dpkg-cross package version 1.26 by Nikita
Youshchenko <yoush@debian.org>, cc'd (CVS version 1.15):
Wed Oct 26 19:51:56 2005 UTC (3 years, 3 months ago)

http://alioth.debian.org/plugins/scmcvs/cvsweb.php/dpkg-cross/dpkg-cross.diff?r1=1.14;r2=1.15;cvsroot=dpkg-cross

(when Nikita was still yoush-guest at Alioth) and has not been touched
since.

Nikita - can you shed some more light on this change and why it was
necessary?

I'd like to resolve this before dpkg-cross merges into dpkg as I'm not
sure the current behaviour would be acceptable for a component of
dpkg-dev, at least not with the current lack of explanation.

It appears that the code was initially meant to cover changes in the
internal layout of a -cross package but although dcvN implicitly
supported incrementing the number, it was never changed and the
subroutines are still hard-coded at dcv1.

Attached is a possible patch that reverts the dcv1 change whilst
retaining later changes.

$ cd /opt/working/dpkg-cross/test/
$ dpkg-cross -b /opt/working/dpkg-cross/test/libqof1_0.7.5-1_arm.deb 
Building libqof1-arm-cross_0.7.5-1_all.deb
dpkg-deb: building package `libqof1-arm-cross' in `./libqof1-arm-cross_0.7.5-1_all.deb'.
$ cd /tmp/
$ ./dpkg-cross -b /opt/working/dpkg-cross/test/libqof1_0.7.5-1_arm.deb 
Building libqof1-arm-cross_0.7.5-1_all.deb
dpkg-deb: building package `libqof1-arm-cross' in `./libqof1-arm-cross_0.7.5-1_all.deb'.

$ debdiff /opt/working/dpkg-cross/test/./libqof1-arm-cross_0.7.5-1_all.deb ./libqof1-arm-cross_0.7.5-1_all.deb
File lists identical (after any substitutions)

Control files: lines which differ (wdiff format)
------------------------------------------------
Depends: libc6-arm-cross (>= 2.7-1), [-libc6-arm-dcv1,-] libgda3-3-arm-cross, [-libgda3-3-arm-dcv1,-] libglib2.0-0-arm-cross (>= [-2.12.0), libglib2.0-0-arm-dcv1-] {+2.12.0)+}
[-Provides: libqof1-arm-dcv1-]

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[514249.diff (text/x-diff, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Tags added: patch Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Tue, 10 Feb 2009 15:00:09 GMT) Full text and rfc822 format available.

Message sent on to Wookey <wookey@debian.org>:
Bug#514249. (Tue, 10 Feb 2009 15:00:16 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#514249; Package dpkg-cross. (Tue, 10 Feb 2009 20:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Nikita V. Youshchenko" <yoush@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Tue, 10 Feb 2009 20:57:07 GMT) Full text and rfc822 format available.

Message #20 received at 514249@bugs.debian.org (full text, mbox):

From: "Nikita V. Youshchenko" <yoush@debian.org>
To: Neil Williams <codehelp@debian.org>
Cc: 514249@bugs.debian.org, 514249-submitter@bugs.debian.org, control@bugs.debian.org
Subject: Re: History of the change
Date: Tue, 10 Feb 2009 23:43:07 +0300
[Message part 1 (text/plain, inline)]
Hi

> Nikita - can you shed some more light on this change and why it was
> necessary?

As far as I can remember, there have been some moment when -$arch-cross 
created by "older" version of dpkg-cross became incompatible 
with -$arch-cross packages created by "newer" version.
So something was needed to stop -$arch-cross packages created by "older" 
dpkg-cross from satisfying dependences of the -$arch-cross packages 
created by "newer" dpkg-cross.
To solve that, "layout versions" have been introduced.

I can't remember all the details now - too many time passed :).

Nikita
[signature.asc (application/pgp-signature, inline)]

Message sent on to Wookey <wookey@debian.org>:
Bug#514249. (Tue, 10 Feb 2009 21:00:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#514249; Package dpkg-cross. (Sun, 15 Feb 2009 11:06:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Sun, 15 Feb 2009 11:06:07 GMT) Full text and rfc822 format available.

Message #28 received at 514249@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 514249@bugs.debian.org
Cc: 514249-submitter@bugs.debian.org
Subject: Implementing the patch
Date: Sun, 15 Feb 2009 11:03:23 +0000
[Message part 1 (text/plain, inline)]
Package: dpkg-cross
tag 514249 + pending
thanks

Now that Lenny has been released, I can't see any reason to retain
-dcv1 packages in Squeeze, especially as dpkg-cross is destined to be
part of dpkg by then.

I've implemented the patch above and I'm going to upload 2.4.0 to
Debian unstable with -dcv1 provision removed.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Message sent on to Wookey <wookey@debian.org>:
Bug#514249. (Sun, 15 Feb 2009 11:06:15 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#514249; Package dpkg-cross. (Sun, 15 Feb 2009 11:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Sun, 15 Feb 2009 11:27:06 GMT) Full text and rfc822 format available.

Message #36 received at 514249@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 514249@bugs.debian.org
Cc: 514249-submitter@bugs.debian.org
Subject: Re: Bug#514249: Implementing the patch
Date: Sun, 15 Feb 2009 11:24:29 +0000
[Message part 1 (text/plain, inline)]
On Sun, 15 Feb 2009 11:03:23 +0000
Neil Williams <codehelp@debian.org> wrote:

> Now that Lenny has been released, I can't see any reason to retain
> -dcv1 packages in Squeeze, especially as dpkg-cross is destined to be
> part of dpkg by then.
> 
> I've implemented the patch above and I'm going to upload 2.4.0 to
> Debian unstable with -dcv1 provision removed.

One amendment to the patch - in order for newly built -cross packages
to not only be installable but also not to break reverse dependencies
that have not yet been updated to remove the -dcv1 dependency, the
patch has been tweaked to retain the Provides: without adding the
dependency:

Index: dpkg-cross
===================================================================
RCS file: /cvsroot/dpkg-cross/dpkg-cross/dpkg-cross,v
retrieving revision 1.67
diff -p -u -b -B -r1.67 dpkg-cross
--- dpkg-cross	15 Feb 2009 11:04:18 -0000	1.67
+++ dpkg-cross	15 Feb 2009 11:19:31 -0000
@@ -1009,8 +1009,13 @@ sub sub_build {
 	}
 
 	# Rewrite dependency fields
+	# Make 'provides' field to exist always to all $package-$arch-dcv1
+	# but create no dependencies on dcv1 - see #514249
+	$control{"provides"} = "" unless defined $control{"provides"};
 	for $field qw(depends conflicts provides replaces) {
 		next if not defined $control{$field};
+		print CONTROL ucfirst($field) . ": ".$control{"package"} ."-$arch-dcv1\n"
+			if ($field eq "provides");
 		my $rewritten = rewrite_dependencies($control{$field});
 		if (length($rewritten) > 0) {
 			# Capitalize first letter of field name

 Package: libqof1-arm-cross
 Version: 0.7.5-1
 Section: devel
 Priority: extra
 Architecture: all
 Maintainer: Debian QOF packaging team <pkg-qof-maintainers@lists.alioth.debian.org>
 Source: libqof1
 Depends: libc6-arm-cross (>= 2.7-1), libgda3-3-arm-cross, libglib2.0-0-arm-cross (>= 2.12.0)
 Conflicts: pilot-qof-arm-cross (<< 0.1.1-2)
 Provides: libqof1-arm-dcv1

This allows libqof-dev to remain installed with dependencies met, until
it is updated itself.

$ apt-cache show libqof-dev-arm-cross
Package: libqof-dev-arm-cross
Status: install ok installed
Priority: extra
Section: devel
Maintainer: Debian QOF packaging team <pkg-qof-maintainers@lists.alioth.debian.org>
Architecture: all
Source: libqof-dev
Version: 0.7.5-1
Provides: libqof-dev-arm-dcv1
Depends: libgda3-dev-arm-cross, libgda3-dev-arm-dcv1, libqof1-arm-cross (= 0.7.5-1), libqof1-arm-dcv1

The Provides itself can be removed in Squeeze+1.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Message sent on to Wookey <wookey@debian.org>:
Bug#514249. (Sun, 15 Feb 2009 11:27:07 GMT) Full text and rfc822 format available.

Tags added: pending Request was from "Neil Williams" <neil@codehelp.co.uk> to control@bugs.debian.org. (Sun, 15 Feb 2009 11:39:14 GMT) Full text and rfc822 format available.

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Sun, 15 Feb 2009 14:18:39 GMT) Full text and rfc822 format available.

Notification sent to Wookey <wookey@debian.org>:
Bug acknowledged by developer. (Sun, 15 Feb 2009 14:18:39 GMT) Full text and rfc822 format available.

Message #46 received at 514249-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 514249-close@bugs.debian.org
Subject: Bug#514249: fixed in dpkg-cross 2.4.0
Date: Sun, 15 Feb 2009 13:59:24 +0000
Source: dpkg-cross
Source-Version: 2.4.0

We believe that the bug you reported is fixed in the latest version of
dpkg-cross, which is due to be installed in the Debian FTP archive:

dpkg-cross_2.4.0.dsc
  to pool/main/d/dpkg-cross/dpkg-cross_2.4.0.dsc
dpkg-cross_2.4.0.tar.gz
  to pool/main/d/dpkg-cross/dpkg-cross_2.4.0.tar.gz
dpkg-cross_2.4.0_all.deb
  to pool/main/d/dpkg-cross/dpkg-cross_2.4.0_all.deb
libdebian-dpkgcross-perl_2.4.0_all.deb
  to pool/main/d/dpkg-cross/libdebian-dpkgcross-perl_2.4.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 514249@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated dpkg-cross package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 15 Feb 2009 11:25:46 +0000
Source: dpkg-cross
Binary: dpkg-cross libdebian-dpkgcross-perl
Architecture: source all
Version: 2.4.0
Distribution: unstable
Urgency: low
Maintainer: Debian Embedded Group <debian-embedded@lists.debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 dpkg-cross - tools for cross compiling Debian packages
 libdebian-dpkgcross-perl - functions to aid cross-compiling Debian packages
Closes: 447427 493180 499292 506229 506956 513203 514249 514604
Changes: 
 dpkg-cross (2.4.0) unstable; urgency=low
 .
   * Merge Emdebian releases into Debian.
   * Remove dependencies on outdated -dcv1 compatibility packages,
     retain Provides for now. (Closes: #514249)
 .
 dpkg-cross (2.3.6) unstable; urgency=low
 .
   * Fix cache support for packages with unusual AC_INIT calls.
   * Add cache support for mipsel.
 .
 dpkg-cross (2.3.5) unstable; urgency=low
 .
   * [INTL:es] Spanish debconf template translation for dpkg-cross
     (Closes: #514604)
   * Implement support for package-specific cache values using CONFIG_SITE
     and /etc/dpkg-cross/cross-config.d/$arch support. (Closes: #493180)
 .
 dpkg-cross (2.3.4) unstable; urgency=low
 .
   * Fix "dpkg-cross fails to provide correct .pc for libpthread-stubs0-
     dev" by marking pkgconfig files in /usr/share/ as 'useful'.
     (Closes: #506229)
   * Allow an exception so that dpkg-cross can handle symlinks to
     pkgconfig files. (Closes: #506956)
   * Debian/DpkgCross.pm :Add a note to endiannes function that dpkg-
     cross needs to be installed as well as the perl module in order for
     the function to retrieve the endianness data.
   * Add missing cache values for findutils to allow findutils to remove
     the cache file. (Closes: #513203)
 .
 dpkg-cross (2.3.3) unstable; urgency=low
 .
   * Migrate gccross to emdebian-tools
   *  + to aid migration of dpkg-cross into dpkg and dpkg-dev
   *  + to retain gccross support until all packages are fixed
   *  + to implement support for marking all packages using gccross as
     buggy.
   * drop buildcross which is now implemented inside emdebuild if
     '[X-]Build-Cross-Libtool: yes' is used in debian/xcontrol
   * dpkg-cross : migrate manpage content to POD for compatibility with
     dpkg-dev
   * migrate default options into the module instead of the conffile
   * check for and remove dangling symlinks (Closes: #499292) by
     stopping the creation of symlinks for files that are not
     interesting.
   * remove obsolete files from CVS and source tarball
   * using pod2man, so drop docbook-to-man build-depends
   * Improve error checking in case  value really is undefined
   * Add dynamic archtable settings to make it easier to support uClibc
     permutations: please support wrong architecture (Closes: #447427)
   * dpkg-cross : Remove cairo hack and finish simplifying the regexp
     lines to remove unnecessary escape characters.
   * debian/rules: final tweak to update from i18n update, clean up
     module man page
 .
 dpkg-cross (2.3.2) unstable; urgency=low
 .
   * Support package-specific cache values
   * config/cross-config.arm config/cross-config.armel : load the global
     variables before the previous values to retain the architecture-
     dependent values
   * config/cross-config.cache : drop orbit data (specialized support
     elsewhere) and reorganise blocks alphabetically
   * dpkg-cross : Implement support for generated cache data in
     /etc/dpkg-cross/cross-config.d/ and architecture-dependent sub
     directories
   * config/cross-config.cache : wrap cache values in package and
     package_name conditionals. Restrict loading of files in
     /etc/dpkg-cross/cross-config.d/ to files matching the package_name
     variable assigned within ./configure.
   * dpkg-cross : Support installing cmake files in -dev packages.
   * Adapt the experimental CMake example file for (hopefully) different
     Linux architectures
   * Add a few CMake tips to the dpkg-cross manpage
 .
 dpkg-cross (2.3.1) unstable; urgency=low
 .
   * Support collected cache values for system-wide comparisons
Checksums-Sha1: 
 f59caff76c01420b6553ac3d43a9210020474ceb 1223 dpkg-cross_2.4.0.dsc
 f5c1d37fec5c40f457c4c3ef2fa6ecc5d4cffc03 73460 dpkg-cross_2.4.0.tar.gz
 2a672b2cd9761f4e1f69181e43c764987952a589 50356 dpkg-cross_2.4.0_all.deb
 c7ca74a045e4f16da668d93f3bac8ba54fd78a1e 32918 libdebian-dpkgcross-perl_2.4.0_all.deb
Checksums-Sha256: 
 f78769677f00f88076360d531a579d5418f644e2dc1bbf709f92c4caf739f46b 1223 dpkg-cross_2.4.0.dsc
 04240bac9c74eff2d8189fe1c43fa0a0b8db1152901035c73e6b78739108303b 73460 dpkg-cross_2.4.0.tar.gz
 1e544fc008b02ec2a49fd06fe884ae69d5c67a8288a64dbeb39c5b4629a3b0ce 50356 dpkg-cross_2.4.0_all.deb
 73427b798ac560776b80413acf6d38c2607550d4eff9d642b0c83a06ce34e6db 32918 libdebian-dpkgcross-perl_2.4.0_all.deb
Files: 
 553387c5146e86fa5dda3e4275719bd4 1223 utils extra dpkg-cross_2.4.0.dsc
 6fefb3522eee6cc2ecbb4c1a2e07ed85 73460 utils extra dpkg-cross_2.4.0.tar.gz
 45a4cc048975bf52f7cb05a00e3a707d 50356 utils extra dpkg-cross_2.4.0_all.deb
 486eb96b50c2d888ed8d705ba8ffae4e 32918 perl extra libdebian-dpkgcross-perl_2.4.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkmYFj8ACgkQiAEJSii8s+Nx9QCfRZHVrXhe3DkuoVbBFpP9WZ16
TmwAnj3yhbap6qeWltV4cu7ttM/Dor+U
=U8XH
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 26 Mar 2009 07:36:48 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 00:51:05 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.